# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`fail2ban`](#fail2ban): == Class: fail2ban
* [`fail2ban::config`](#fail2ban--config): == Class: fail2ban::config
* [`fail2ban::install`](#fail2ban--install): == Class: fail2ban::install
* [`fail2ban::service`](#fail2ban--service): == Class: fail2ban::service

### Defined types

* [`fail2ban::define`](#fail2ban--define): == Define: fail2ban::define
* [`fail2ban::jail`](#fail2ban--jail): == Define: fail2ban::jail

## Classes

### <a name="fail2ban"></a>`fail2ban`

== Class: fail2ban

#### Parameters

The following parameters are available in the `fail2ban` class:

* [`config_file_before`](#-fail2ban--config_file_before)
* [`package_ensure`](#-fail2ban--package_ensure)
* [`package_name`](#-fail2ban--package_name)
* [`package_list`](#-fail2ban--package_list)
* [`config_dir_path`](#-fail2ban--config_dir_path)
* [`config_dir_filter_path`](#-fail2ban--config_dir_filter_path)
* [`config_dir_purge`](#-fail2ban--config_dir_purge)
* [`config_dir_recurse`](#-fail2ban--config_dir_recurse)
* [`config_dir_source`](#-fail2ban--config_dir_source)
* [`config_file_path`](#-fail2ban--config_file_path)
* [`config_file_owner`](#-fail2ban--config_file_owner)
* [`config_file_group`](#-fail2ban--config_file_group)
* [`config_file_mode`](#-fail2ban--config_file_mode)
* [`config_file_source`](#-fail2ban--config_file_source)
* [`config_file_string`](#-fail2ban--config_file_string)
* [`config_file_template`](#-fail2ban--config_file_template)
* [`config_file_notify`](#-fail2ban--config_file_notify)
* [`config_file_require`](#-fail2ban--config_file_require)
* [`config_file_hash`](#-fail2ban--config_file_hash)
* [`config_file_options_hash`](#-fail2ban--config_file_options_hash)
* [`manage_defaults`](#-fail2ban--manage_defaults)
* [`manage_firewalld`](#-fail2ban--manage_firewalld)
* [`service_ensure`](#-fail2ban--service_ensure)
* [`service_name`](#-fail2ban--service_name)
* [`service_enable`](#-fail2ban--service_enable)
* [`action`](#-fail2ban--action)
* [`bantime`](#-fail2ban--bantime)
* [`email`](#-fail2ban--email)
* [`sender`](#-fail2ban--sender)
* [`iptables_chain`](#-fail2ban--iptables_chain)
* [`jails`](#-fail2ban--jails)
* [`maxretry`](#-fail2ban--maxretry)
* [`default_backend`](#-fail2ban--default_backend)
* [`whitelist`](#-fail2ban--whitelist)
* [`custom_jails`](#-fail2ban--custom_jails)
* [`banaction`](#-fail2ban--banaction)
* [`sendmail_config`](#-fail2ban--sendmail_config)
* [`sendmail_actions`](#-fail2ban--sendmail_actions)

##### <a name="-fail2ban--config_file_before"></a>`config_file_before`

Data type: `String[1]`



##### <a name="-fail2ban--package_ensure"></a>`package_ensure`

Data type: `Enum['absent', 'latest', 'present', 'purged']`



Default value: `'present'`

##### <a name="-fail2ban--package_name"></a>`package_name`

Data type: `String[1]`



Default value: `'fail2ban'`

##### <a name="-fail2ban--package_list"></a>`package_list`

Data type: `Optional[Array[String]]`



Default value: `undef`

##### <a name="-fail2ban--config_dir_path"></a>`config_dir_path`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/fail2ban'`

##### <a name="-fail2ban--config_dir_filter_path"></a>`config_dir_filter_path`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/fail2ban/filter.d'`

##### <a name="-fail2ban--config_dir_purge"></a>`config_dir_purge`

Data type: `Boolean`



Default value: `false`

##### <a name="-fail2ban--config_dir_recurse"></a>`config_dir_recurse`

Data type: `Boolean`



Default value: `true`

##### <a name="-fail2ban--config_dir_source"></a>`config_dir_source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--config_file_path"></a>`config_file_path`

Data type: `Stdlib::Absolutepath`



Default value: `'/etc/fail2ban/jail.conf'`

##### <a name="-fail2ban--config_file_owner"></a>`config_file_owner`

Data type: `String[1]`



Default value: `'root'`

##### <a name="-fail2ban--config_file_group"></a>`config_file_group`

Data type: `String[1]`



Default value: `'root'`

##### <a name="-fail2ban--config_file_mode"></a>`config_file_mode`

Data type: `String[1]`



Default value: `'0644'`

##### <a name="-fail2ban--config_file_source"></a>`config_file_source`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-fail2ban--config_file_string"></a>`config_file_string`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-fail2ban--config_file_template"></a>`config_file_template`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-fail2ban--config_file_notify"></a>`config_file_notify`

Data type: `String[1]`



Default value: `'Service[fail2ban]'`

##### <a name="-fail2ban--config_file_require"></a>`config_file_require`

Data type: `String[1]`



Default value: `'Package[fail2ban]'`

##### <a name="-fail2ban--config_file_hash"></a>`config_file_hash`

Data type: `Hash[String[1], Any]`



Default value: `{}`

##### <a name="-fail2ban--config_file_options_hash"></a>`config_file_options_hash`

Data type: `Hash`



Default value: `{}`

##### <a name="-fail2ban--manage_defaults"></a>`manage_defaults`

Data type: `Enum['absent', 'present']`



Default value: `'absent'`

##### <a name="-fail2ban--manage_firewalld"></a>`manage_firewalld`

Data type: `Enum['absent', 'present']`



Default value: `'absent'`

##### <a name="-fail2ban--service_ensure"></a>`service_ensure`

Data type: `Enum['running', 'stopped']`



Default value: `'running'`

##### <a name="-fail2ban--service_name"></a>`service_name`

Data type: `String[1]`



Default value: `'fail2ban'`

##### <a name="-fail2ban--service_enable"></a>`service_enable`

Data type: `Boolean`



Default value: `true`

##### <a name="-fail2ban--action"></a>`action`

Data type: `String[1]`



Default value: `'action_mb'`

##### <a name="-fail2ban--bantime"></a>`bantime`

Data type: `Variant[Integer[0], String[1]]`



Default value: `432000`

##### <a name="-fail2ban--email"></a>`email`

Data type: `String[1]`



Default value: `"fail2ban@${facts['networking']['domain']}"`

##### <a name="-fail2ban--sender"></a>`sender`

Data type: `String[1]`



Default value: `"fail2ban@${facts['networking']['fqdn']}"`

##### <a name="-fail2ban--iptables_chain"></a>`iptables_chain`

Data type: `String[1]`



Default value: `'INPUT'`

##### <a name="-fail2ban--jails"></a>`jails`

Data type: `Array[String[1]]`



Default value: `['ssh', 'ssh-ddos']`

##### <a name="-fail2ban--maxretry"></a>`maxretry`

Data type: `Integer[0]`



Default value: `3`

##### <a name="-fail2ban--default_backend"></a>`default_backend`

Data type: `Enum['pyinotify', 'gamin', 'polling', 'systemd', 'auto']`



Default value: `'auto'`

##### <a name="-fail2ban--whitelist"></a>`whitelist`

Data type: `Array`



Default value: `['127.0.0.1/8', '192.168.56.0/24']`

##### <a name="-fail2ban--custom_jails"></a>`custom_jails`

Data type: `Hash[String, Hash]`



Default value: `{}`

##### <a name="-fail2ban--banaction"></a>`banaction`

Data type: `String[1]`



Default value: `'iptables-multiport'`

##### <a name="-fail2ban--sendmail_config"></a>`sendmail_config`

Data type: `Hash`



Default value: `{}`

##### <a name="-fail2ban--sendmail_actions"></a>`sendmail_actions`

Data type: `Hash`



Default value: `{}`

### <a name="fail2ban--config"></a>`fail2ban::config`

== Class: fail2ban::config

### <a name="fail2ban--install"></a>`fail2ban::install`

== Class: fail2ban::install

### <a name="fail2ban--service"></a>`fail2ban::service`

== Class: fail2ban::service

## Defined types

### <a name="fail2ban--define"></a>`fail2ban::define`

== Define: fail2ban::define

#### Parameters

The following parameters are available in the `fail2ban::define` defined type:

* [`config_file_path`](#-fail2ban--define--config_file_path)
* [`config_file_owner`](#-fail2ban--define--config_file_owner)
* [`config_file_group`](#-fail2ban--define--config_file_group)
* [`config_file_mode`](#-fail2ban--define--config_file_mode)
* [`config_file_source`](#-fail2ban--define--config_file_source)
* [`config_file_string`](#-fail2ban--define--config_file_string)
* [`config_file_template`](#-fail2ban--define--config_file_template)
* [`config_file_notify`](#-fail2ban--define--config_file_notify)
* [`config_file_require`](#-fail2ban--define--config_file_require)
* [`config_file_options_hash`](#-fail2ban--define--config_file_options_hash)

##### <a name="-fail2ban--define--config_file_path"></a>`config_file_path`

Data type: `Stdlib::Absolutepath`



Default value: `"${fail2ban::config_dir_path}/${title}"`

##### <a name="-fail2ban--define--config_file_owner"></a>`config_file_owner`

Data type: `String`



Default value: `$fail2ban::config_file_owner`

##### <a name="-fail2ban--define--config_file_group"></a>`config_file_group`

Data type: `String`



Default value: `$fail2ban::config_file_group`

##### <a name="-fail2ban--define--config_file_mode"></a>`config_file_mode`

Data type: `String`



Default value: `$fail2ban::config_file_mode`

##### <a name="-fail2ban--define--config_file_source"></a>`config_file_source`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--define--config_file_string"></a>`config_file_string`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--define--config_file_template"></a>`config_file_template`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--define--config_file_notify"></a>`config_file_notify`

Data type: `String`



Default value: `$fail2ban::config_file_notify`

##### <a name="-fail2ban--define--config_file_require"></a>`config_file_require`

Data type: `String`



Default value: `$fail2ban::config_file_require`

##### <a name="-fail2ban--define--config_file_options_hash"></a>`config_file_options_hash`

Data type: `Hash`



Default value: `$fail2ban::config_file_options_hash`

### <a name="fail2ban--jail"></a>`fail2ban::jail`

== Define: fail2ban::jail

#### Parameters

The following parameters are available in the `fail2ban::jail` defined type:

* [`filter_includes`](#-fail2ban--jail--filter_includes)
* [`filter_failregex`](#-fail2ban--jail--filter_failregex)
* [`filter_ignoreregex`](#-fail2ban--jail--filter_ignoreregex)
* [`filter_maxlines`](#-fail2ban--jail--filter_maxlines)
* [`filter_datepattern`](#-fail2ban--jail--filter_datepattern)
* [`filter_additional_config`](#-fail2ban--jail--filter_additional_config)
* [`enabled`](#-fail2ban--jail--enabled)
* [`action`](#-fail2ban--jail--action)
* [`filter`](#-fail2ban--jail--filter)
* [`logpath`](#-fail2ban--jail--logpath)
* [`maxretry`](#-fail2ban--jail--maxretry)
* [`findtime`](#-fail2ban--jail--findtime)
* [`bantime`](#-fail2ban--jail--bantime)
* [`port`](#-fail2ban--jail--port)
* [`backend`](#-fail2ban--jail--backend)
* [`journalmatch`](#-fail2ban--jail--journalmatch)
* [`ignoreip`](#-fail2ban--jail--ignoreip)
* [`config_dir_filter_path`](#-fail2ban--jail--config_dir_filter_path)
* [`config_file_owner`](#-fail2ban--jail--config_file_owner)
* [`config_file_group`](#-fail2ban--jail--config_file_group)
* [`config_file_mode`](#-fail2ban--jail--config_file_mode)
* [`config_file_source`](#-fail2ban--jail--config_file_source)
* [`config_file_notify`](#-fail2ban--jail--config_file_notify)
* [`config_file_require`](#-fail2ban--jail--config_file_require)

##### <a name="-fail2ban--jail--filter_includes"></a>`filter_includes`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--filter_failregex"></a>`filter_failregex`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--filter_ignoreregex"></a>`filter_ignoreregex`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--filter_maxlines"></a>`filter_maxlines`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-fail2ban--jail--filter_datepattern"></a>`filter_datepattern`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--filter_additional_config"></a>`filter_additional_config`

Data type: `Any`



Default value: `undef`

##### <a name="-fail2ban--jail--enabled"></a>`enabled`

Data type: `Boolean`



Default value: `true`

##### <a name="-fail2ban--jail--action"></a>`action`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--filter"></a>`filter`

Data type: `String`



Default value: `$title`

##### <a name="-fail2ban--jail--logpath"></a>`logpath`

Data type: `String`



Default value: `undef`

##### <a name="-fail2ban--jail--maxretry"></a>`maxretry`

Data type: `Integer`



Default value: `$fail2ban::maxretry`

##### <a name="-fail2ban--jail--findtime"></a>`findtime`

Data type: `Optional[Integer]`



Default value: `undef`

##### <a name="-fail2ban--jail--bantime"></a>`bantime`

Data type: `Integer`



Default value: `$fail2ban::bantime`

##### <a name="-fail2ban--jail--port"></a>`port`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--backend"></a>`backend`

Data type: `Optional[String]`



Default value: `undef`

##### <a name="-fail2ban--jail--journalmatch"></a>`journalmatch`

Data type: `Optional[String[1]]`



Default value: `undef`

##### <a name="-fail2ban--jail--ignoreip"></a>`ignoreip`

Data type: `Array[Stdlib::IP::Address]`



Default value: `[]`

##### <a name="-fail2ban--jail--config_dir_filter_path"></a>`config_dir_filter_path`

Data type: `Stdlib::Absolutepath`



Default value: `$fail2ban::config_dir_filter_path`

##### <a name="-fail2ban--jail--config_file_owner"></a>`config_file_owner`

Data type: `Optional[String]`



Default value: `$fail2ban::config_file_owner`

##### <a name="-fail2ban--jail--config_file_group"></a>`config_file_group`

Data type: `Optional[String]`



Default value: `$fail2ban::config_file_group`

##### <a name="-fail2ban--jail--config_file_mode"></a>`config_file_mode`

Data type: `Optional[String]`



Default value: `$fail2ban::config_file_mode`

##### <a name="-fail2ban--jail--config_file_source"></a>`config_file_source`

Data type: `Optional[String]`



Default value: `$fail2ban::config_file_source`

##### <a name="-fail2ban--jail--config_file_notify"></a>`config_file_notify`

Data type: `Optional[String]`



Default value: `$fail2ban::config_file_notify`

##### <a name="-fail2ban--jail--config_file_require"></a>`config_file_require`

Data type: `Optional[String]`



Default value: `$fail2ban::config_file_require`

